var url = require("url");
var fs = require("fs");

exports.routeRequest = function(req, res) {
	// first, strip a /pub/ off the front if it exists
	var originalurl = url.parse(req.url);
		
	thisurl = originalurl.pathname.replace(/^\/pub/, "");
	
	console.log("pathname now: ", thisurl);
	
	//if(thisurl.pathname == "") thisurl.pathname = "/";
	
	var reqpath = global.repoproxy.cacheDir + "/" + thisurl;
	
	console.log("request on '%s'", reqpath);

	// see what we're dealing with
	fs.stat(reqpath, function(err, stat) {
		console.log("err is ", err);
		console.log("stat is ", stat);
		console.log("fs.stats is ", fs.stats);
		
		if(err == null) {
			if(stat.isDirectory()) {
				if(originalurl.pathname.charAt(originalurl.pathname.length-1) != "/") {
					// redirect to url + "/"
					res.writeHead("302", { "Location": originalurl.pathname+"/" });
					res.end();
				} else {
					writeDirectoryListing(reqpath, originalurl.pathname, res);
				}
			} else {
				if(stat.isFile()) {
					fs.readFile(reqpath, "utf8", function(err, data) {
						res.write(data);
						res.end();
					});
				}
			}
		} else {
			// go upstream..
			res.write("here we need to go upstream");
			res.end();
		}
	});	
}

function writeDirectoryListing(reqpath, requesturi, res) {
	res.write("<html><h1>Directory listing for " + requesturi + "</h1><hr><pre>");
	if(requesturi != "/") res.write("<a href=\"..\">Parent</a>\n\n");
	fs.readdir(reqpath, function(err, files) {
		console.log("doing directory listing on: ", reqpath);
		if(err == null) {
			
			// TODO: make this work asynchronously...
			if(files.length == 0) {
				res.write("Empty Directory....\b");
			} else {
				for(var i=0; i<files.length; i++) {
					// avoiding statSync is too hard for now, will fix later TODO: fix this sync bit
					var stats = fs.statSync(reqpath+"/"+files[i]);
					
					if(stats.isDirectory()) {
						
						res.write("Directory: <a href=\""+files[i]+"/\">"+files[i]+"/</a>\n");
					} else if(stats.isFile()) {
						var padlength = 80 - (files[i].length) - stats.size.toString().length;
						var padding = "";
						if(padlength > 0) {
							padding = new Array(padlength).join(" ");
						}
						res.write("File:      <a href=\""+files[i]+"\">"+files[i]+"</a>"+padding+stats.size+" bytes\n");
					}
				}
			}
			res.write("<hr></pre>");
			res.end();
		} else {
			res.write("we have entered bizaro world...\n");
			res.write("</pre>");
			res.end();
		}
	});
}